//
// $Id: OShortestMoveTo.h,v 1.1 1997/10/28 05:11:43 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import <AppKit/AppKit.h>
#import "Empire.h"
#import "OMoveTo.h"

@class SNGraphNode;

//======================================================================

@interface OShortestMoveTo : OMoveTo
{
    MovementType movementType;
  
    Map *map;

    SNGraphNode **nodes;
    SNGraphNode ***nodePointers;
}

+ (void) initialize;

- initForUnit:(Unit *)aUnit moveToLocation:(EMMapLocation)newLocation onMap:(Map *)thisMap;
- (void) dealloc;

- copyWithZone:(NSZone *)zone;

- (NSString *) orderText;

- (void) aboutToMove;

- (Direction) nextMove;
- (Direction) nextMoveWithin:(int)distance;

- (BOOL) isTooClose:(int)distance;
- (BOOL) wasBlocked;

- (SNGraphNode *) nodeAtLocation:(EMMapLocation)target;
- (void) doBFSFromLocation:(EMMapLocation)target;

- (void) reset;

- (NSArray *) pathsForMapView:(MapView *)mapView;

@end
