//
// $Id: SNImage.m,v 1.7 1997/10/31 04:52:04 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import "Empire.h"

RCSID ("$Id: SNImage.m,v 1.7 1997/10/31 04:52:04 nygard Exp $");

#import "SNImage.h"

#import <AppKit/psopsNeXT.h>

//======================================================================
// This handles a small bug in Openstep 4.[01].  When an NSImage is
// cached, it does not ensure that instance drawing has been turned off.
//
// We don't actually have to change any code to use SNImage instead of
// NSImage.  Instead, this just poses as NSImage and no other code
// needs to be changed.
//======================================================================

@implementation SNImage

+ (void) load
{
    // This doesn't work in +initialize
    [self poseAsClass:[NSImage class]];
}

//----------------------------------------------------------------------

- (BOOL) drawRepresentation:(NSImageRep *)imageRep inRect:(NSRect)rect
{
    PSsetinstance (NO);

    return [super drawRepresentation:imageRep inRect:rect];
}

@end
