//
// $Id: ServerController.h,v 1.5 1997/10/23 05:17:55 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//


#import <AppKit/AppKit.h>
#import <Foundation/NSConnection.h>
#import "Empire.h"
#import "EmpireProtocols.h"

@class Client;

//======================================================================

@interface ServerController : NSObject <EmpireServerConnectionProtocol>
{
    IBOutlet NSWindow *serverWindow;
    IBOutlet NSTextField *statusTextfield;

    NSMutableArray *clientList;
    id serverConnection;

    NSMutableArray *observers;
    IBOutlet NSTextView *messageText;

    IBOutlet NSTableView *clientTable;
}

+ (void) initialize;

- (void) awakeFromNib;

- init;
- (void) dealloc;

- (void) showPanel;

- (void) establishServer:sender;
- (void) stopServer:sender;

- (void) doubleAction:sender;

- (void) showText:(NSString *)format, ...;

- (void) connectionDidDie:(NSNotification *)notification;

- (BOOL) connection:(NSConnection *)parentConnection shouldMakeNewConnection:(NSConnection *)newConnection;
- (Client *) clientAtIndex:(int)index;

//======================================================================
// EmpireServerConnectionProtocol
//======================================================================

- (void) ping;
- (void) client:clientController onHost:(NSString *)hostname;
- (void) aboutToDisconnect:sender;

//======================================================================
// NSTableDataSource
//======================================================================

- (int) numberOfRowsInTableView:(NSTableView *)aTableView;
- tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;

//======================================================================
// ObserverPattern
//======================================================================

- (void) attach:observer;
- (void) detach:observer;
- (void) newClientHost:(NSString *)hostname;
- (void) removedClientHostNumber:(int)index;

@end
