//
// $Id: ShipReportController.h,v 1.4 1997/10/22 08:01:24 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import <AppKit/AppKit.h>

@class EmPlayer;

//======================================================================

@interface ShipReportController : NSObject
{
    IBOutlet NSWindow *shipReportWindow;

    IBOutlet NSTableView *shipTable;
    IBOutlet NSTableColumn *iconColumn;

    NSMutableArray *ships;
}

- (void) awakeFromNib;

- init;
- (void) dealloc;

- (int) numberOfRowsInTableView:(NSTableView *)aTableView;
- tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;

- (void) vendorImagesUpdated:(BOOL)player1:(BOOL)player2:(BOOL)player3:(BOOL)other;

- (void) shipReportForPlayer:(EmPlayer *)player;
- (void) shipReportStopAction:sender;

@end
