//
// $Id: WorldMapView.h,v 1.5 1997/10/23 02:25:55 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import <AppKit/AppKit.h>

@class Map;
@class MapView;

//======================================================================

@interface WorldMapView : NSView
{
    id delegate;
    Map *map;

    NSColor *terrainColors[4];
    NSColor *playerColors[4];

    BOOL compressEvents;
}

- initWithFrame:(NSRect)frameRect;
- (void) dealloc;

- (BOOL) acceptsFirstResponder;
- (BOOL) acceptsFirstMouse:(NSEvent *)theEvent;

- (void) drawRect:(NSRect)rect;

- (Map *) map;
- (void) setMap:(Map *)aMap; // retains map

- (void) setCompressEvents:(BOOL)flag;

- (EMMapLocation) getLocationForPoint:(NSPoint)point;
- (NSRect) getRectForLocation:(EMMapLocation)target;
- (NSRect) getRectAround3x3Location:(EMMapLocation)target;

- (void) centerLocation:(EMMapLocation)target ifNotVisible:(BOOL)notVisibleFlag;
- (void) scrollLocationToVisible:(EMMapLocation)target;

- (void) displayLocation:(EMMapLocation)target;
- (void) displayAround3x3Location:(EMMapLocation)target;

- (void) vendorImagesUpdated:(BOOL)player1:(BOOL)player2:(BOOL)player3:(BOOL)other;

//======================================================================
// Map Observer
//======================================================================

- (void) refreshMap;
- (void) refreshLocation:(EMMapLocation)target;
- (void) refresh3x3Location:(EMMapLocation)target;

- (void) mouseDown:(NSEvent *)theEvent;
- (void) mouseUp:(NSEvent *)theEvent;
- (void) keyDown:(NSEvent *)theEvent;

@end
