/* indent:4  tabsize:8  font:fixed-width */

#import "FTDiscardPileDelegate.h"
#import "FTSuitDelegate.h"
//#import <Solitaire/Solitaire.h"
#import "FortyThieves.h"

@implementation FTDiscardPileDelegate

- (void) setSuitCardPileViews:(id [])theViews
{
    int i;
    
    for (i=0; i<8; i++)
        suitCardPileViews[i] = *(theViews + i);
}


- (void) doubleClickedCard:(Card*)aCard in:(CardPileView*)aCardPileView
{
    int i;
    
    CardPile*	cardPile = [aCardPileView cardPile];
    
    if ((aCard == [cardPile topCard] ) && (![aCard isFaceUp]))
    {
	[aCard flip];
	[aCardPileView display];
    }
    else if (aCard == [cardPile topCard])
    {
	for (i=0;i<8;i++)
	{
	    [[suitCardPileViews[i] delegate] setDoubleClickCheck];
	    if ([[suitCardPileViews[i] delegate] canAcceptPile:cardPile
	                                      from:aCardPileView
	                                        in:suitCardPileViews[i]])
	    {
		[[suitCardPileViews[i] cardPile] addCard:[cardPile topCard]];
		[cardPile removeCard:[cardPile topCard]];
		[aCardPileView display];
		[suitCardPileViews[i] display];
		[[FortyThieves sharedInstance] checkForWin];
		break;
	    }
	}
    } 
}


- (BOOL) draggedPile:(CardPile*)aCardPile from:(CardPileView*)discardCardPileView
{
    CardPile* discardCardPile = [discardCardPileView cardPile];

    if (([aCardPile topCard]) == ([discardCardPile topCard]))
    {
        return YES;
    }
    return NO;
}


- (void) getOffset:(float *)xOffset :(float *)yOffset forSize:(CardSize)aSize
{
    if (aSize == CS_SMALL)
    {
    	*xOffset = 12.0;
    }
    else
    {
        *xOffset = 16.0;
    }    
    *yOffset = 0.0; 
}

@end
