/* indent:4  tabsize:8  font:fixed-width */

/*---------------------------------------------------------------------------
|----------------------------------------------------------------------------
|
|    FortyThieves:GameModule
|
|    FortyThieves Solitaire module.
|
|    CREDITS
|
|    Michael McCulloch <michael@hsv.tybrin.com>
|        -- design, implementation, documentation
|
|----------------------------------------------------------------------------
\---------------------------------------------------------------------------*/


#import <AppKit/AppKit.h>
#import <Solitaire/GameModule.h>

// Forward class declarations
@class CardPileView;
@class FTAlertPanel;
@class CardPile;

#define IBOutlet


@interface FortyThieves:GameModule
{
    IBOutlet CardPileView* drawPileView;
    IBOutlet CardPileView* discardPileView;
    IBOutlet FTAlertPanel* peekPanel;
    IBOutlet CardPileView* peekCardView;

    IBOutlet CardPileView* gamePileView1;
    IBOutlet CardPileView* gamePileView2;
    IBOutlet CardPileView* gamePileView3;
    IBOutlet CardPileView* gamePileView4;
    IBOutlet CardPileView* gamePileView5;
    IBOutlet CardPileView* gamePileView6;
    IBOutlet CardPileView* gamePileView7;
    IBOutlet CardPileView* gamePileView8;
    IBOutlet CardPileView* gamePileView9;
    IBOutlet CardPileView* gamePileView10;

    IBOutlet CardPileView* suitPileView1;
    IBOutlet CardPileView* suitPileView2;
    IBOutlet CardPileView* suitPileView3;
    IBOutlet CardPileView* suitPileView4;
    IBOutlet CardPileView* suitPileView5;
    IBOutlet CardPileView* suitPileView6;
    IBOutlet CardPileView* suitPileView7;
    IBOutlet CardPileView* suitPileView8;
    
    id suitPileDelegate;
    id drawPileDelegate;
    id gamePileDelegate;
    id discardPileDelegate;

    CardPile* prevDeck;
}

/*" Our single instance "*/
+ (FortyThieves*) sharedInstance;

/*" Initialization/deallocation "*/
- initFromBundle:(NSBundle*)aBundle withName:(NSString*)name;

- (void) setupGame:(BOOL)redeal;
- (void) peekAtNextCard:sender;

@end
