/* indent:4  tabsize:8  font:fixed-width */

/*---------------------------------------------------------------------------
| -----------------------------------------------------------------------------
|
|	DiscardPileDelegate : NSObject
|
|	<< Description >>
|
| -----------------------------------------------------------------------------
\----------------------------------------------------------------------------*/

#import <AppKit/AppKit.h>
#import <Solitaire/CardSet.h>

@class CardPile;
@class CardPileView;


@interface DiscardPileDelegate : NSObject
{
    CardPile*		recycleCardPile;
    CardPileView*	suitCardPileViews[4];
    int				maxIndex;
}

/*----------------------------------------------------------------------------
|
|	CardPileView delegation methods
|
\---------------------------------------------------------------------------*/

- (void) setDrawCardCount:(int)theCount;
- (void) setSuitCardPileViews:(id [])theViews;
- (void) doubleClickedCard:(Card*)aCard in:(CardPileView*)aCardPileView;
- (BOOL) draggedPile:(CardPile*)aCardPile from:(CardPileView*)discardCardPileView;
- (void) removedPile:(CardPile*)aCardPile from:(CardPileView*)discardCardPileView;
- (void) getOffset:(float*)xOffset :(float*)yOffset forSize:(CardSize)aSize;

@end

