/* indent:4  tabsize:8  font:fixed-width */

#import "GamePileDelegate.h"
#import "SuitPileDelegate.h"
//#import "../Solitaire/Solitaire.h"
#import "Klondike.h"

@implementation GamePileDelegate

- (void) setSuitCardPileViews:(id [])theViews
{
    int i;

    for (i=0; i<4; i++) {
        suitCardPileViews[i] = *(theViews + i);
    }
}
    

- (void) clickedCard:(Card*)aCard in:(CardPileView*)aCardPileView
{
    CardPile* cardPile = [aCardPileView cardPile];

    if ((aCard == [cardPile topCard]) && (![aCard isFaceUp]))
    {
        [aCard flip];
        [aCardPileView display];
    } 
}


- (void) doubleClickedCard:(Card*)aCard in:(CardPileView*)aCardPileView
{
    int i;
    
    CardPile*    cardPile = [aCardPileView cardPile];
    
    if ((aCard == [cardPile topCard]) && (![aCard isFaceUp]))
    {
        [aCard flip];
        [aCardPileView display];
    }
    else if (aCard == [cardPile topCard])
    {
        for (i=0; i<4; i++)
        {
            [[suitCardPileViews[i] delegate] setDoubleClickCheck];
            if ([[suitCardPileViews[i] delegate] canAcceptPile:cardPile
	                                       from:aCardPileView
	                                         in:suitCardPileViews[i]])
            {
                [[suitCardPileViews[i] cardPile] addCard:[cardPile topCard]];
                [cardPile removeCard:[cardPile topCard]];
                [aCardPileView display];
                [suitCardPileViews[i] display];
                [[Klondike sharedInstance] checkForWin];

                break;
            }
        }
    } 
}


- (BOOL) draggedPile:(CardPile*)aCardPile from:(CardPileView*)aCardPileView
{
    CardPile* 	cardPile = [aCardPileView cardPile];
    Card* 		firstCard = [aCardPile topCard];
    int 		cardIndex = [cardPile indexOfCard:firstCard];

    if ([firstCard isFaceUp])
    {
        while (++cardIndex < [cardPile cardCount])
        {
            [aCardPile addCard:[cardPile cardAtIndex:cardIndex]];
        }
        return YES;
    }
    return NO;
}


- (BOOL) canAcceptPile:(CardPile*)aCardPile from:sender in:(CardPileView*)aCardPileView
{
    Card* droppingCard = [aCardPile bottomCard];
    Card* targetCard = [[aCardPileView cardPile] topCard];
    
    if (targetCard)
    {
        if (([targetCard isFaceUp]) &&
                ([targetCard cardColor] != [droppingCard cardColor]) &&
                ([targetCard value] == [droppingCard value] + 1))
        {
            return YES;
        }
    }
    else
    {
        if ([droppingCard value] == CS_KING)
        {
            return YES;
        }
    }
    return NO;
}


- (void) getOffset:(float*)xOffset :(float*)yOffset forSize:(CardSize)aSize
{
    *xOffset = 0.0;
    if (aSize == CS_SMALL)
        *yOffset = 15.0;
    else
        *yOffset = 20.0; 
}

@end

