/* indent:4  tabsize:8  font:fixed-width */

/*--------------------------------------------------------------------------
|---------------------------------------------------------------------------
|
|	WasteCardPileDelegate : NSObject
|
|	An instance of this class acts as a delegate for messages from the
|	Waste Pile in the Pyramid solitaire game.
| --------------------------------------------------------------------------
\--------------------------------------------------------------------------*/

#import <AppKit/AppKit.h>

@class CardPileView;
@class CardPile;
@class Card;


@interface WasteCardPileDelegate:NSObject
{
    CardPileView* discardCardPileViewL;	/* the left discard pile */
    CardPileView* discardCardPileViewR;	/* the right discard pile */
}

/*----------------------------------------------------------------------------
|
|	Delegation setting methods.
|
\---------------------------------------------------------------------------*/

- (void) setDiscardLeft:(CardPileView*)left discardRight:(CardPileView*)right;


/*----------------------------------------------------------------------------
|
|	CardPileView delegation methods
|
\---------------------------------------------------------------------------*/

- (BOOL) canAcceptPile:(CardPile*)aCardPile from:sender in:(CardPileView*)wasteCardPileView;
- (void) acceptPile:(CardPile*)aCardPile in:(CardPileView*)wasteCardPileView;
- (BOOL) draggedPile:(CardPile*)aCardPile from:(CardPileView*)wasteCardPileView;
- (void) doubleClickedCard:(Card*)aCard in:(CardPileView*)aCardPileView;

@end

