/* indent:4  tabsize:8  font:fixed-width */

/*---------------------------------------------------------------------------
|----------------------------------------------------------------------------
|
|    Spider : GameModule
|
|    Spider Solitaire module.
|
|    CREDITS
|
|    Gary Ritchie<gary@uaneuro.uah.ualberta.ca>
|        -- design, implementation, documentation
|
|----------------------------------------------------------------------------
\---------------------------------------------------------------------------*/


#import <AppKit/AppKit.h>
#import <Solitaire/GameModule.h>

@class CardPileView;

#define IBOutlet


@interface Spider : GameModule
{
    IBOutlet CardPileView* drawPileView;

    IBOutlet CardPileView* gamePileView1;
    IBOutlet CardPileView* gamePileView2;
    IBOutlet CardPileView* gamePileView3;
    IBOutlet CardPileView* gamePileView4;
    IBOutlet CardPileView* gamePileView5;
    IBOutlet CardPileView* gamePileView6;
    IBOutlet CardPileView* gamePileView7;
    IBOutlet CardPileView* gamePileView8;
    IBOutlet CardPileView* gamePileView9;
    IBOutlet CardPileView* gamePileView10;

    IBOutlet CardPileView* suitPileView1;
    IBOutlet CardPileView* suitPileView2;
    IBOutlet CardPileView* suitPileView3;
    IBOutlet CardPileView* suitPileView4;
    IBOutlet CardPileView* suitPileView5;
    IBOutlet CardPileView* suitPileView6;
    IBOutlet CardPileView* suitPileView7;
    IBOutlet CardPileView* suitPileView8;
    
    id			suitPileDelegate;
    id 			drawPileDelegate;
    id 			gamePileDelegate;

    CardPile* 	prevDeck;
}

/*" Our single instance "*/
+ (Spider*) sharedInstance;

/*" Initialization/deallocation "*/
- initFromBundle:(NSBundle*)aBundle withName:(NSString*)name;

/*" Game specific "*/
- (void) setupGame:(BOOL)redeal;

@end
